diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/examples/wireless/wifi-he-network.cc ns-3.44/examples/wireless/wifi-he-network.cc
--- ns-3.43/examples/wireless/wifi-he-network.cc	2024-10-09 16:41:09.840655800 -0700
+++ ns-3.44/examples/wireless/wifi-he-network.cc	2025-03-09 16:55:49.339371000 -0700
@@ -6,6 +6,7 @@
  * Author: Sebastien Deronne <sebastien.deronne@gmail.com>
  */
 
+#include "ns3/attribute-container.h"
 #include "ns3/boolean.h"
 #include "ns3/command-line.h"
 #include "ns3/config.h"
@@ -31,6 +32,7 @@
 #include "ns3/yans-wifi-channel.h"
 #include "ns3/yans-wifi-helper.h"
 
+#include <algorithm>
 #include <functional>
 
 // This is a simple example in order to show how to configure an IEEE 802.11ax Wi-Fi network.
@@ -70,12 +72,15 @@
     std::string dlAckSeqType{"NO-OFDMA"};
     bool enableUlOfdma{false};
     bool enableBsrp{false};
-    int mcs{-1}; // -1 indicates an unset value
+    std::string mcsStr;
+    std::vector<uint64_t> mcsValues;
+    int channelWidth{-1};  // in MHz, -1 indicates an unset value
+    int guardInterval{-1}; // in nanoseconds, -1 indicates an unset value
     uint32_t payloadSize =
         700; // must fit in the max TX duration when transmitting at MCS 0 over an RU of 26 tones
     std::string phyModel{"Yans"};
-    double minExpectedThroughput{0};
-    double maxExpectedThroughput{0};
+    double minExpectedThroughput{0.0};
+    double maxExpectedThroughput{0.0};
     Time accessReqInterval{0};
 
     CommandLine cmd(__FILE__);
@@ -107,7 +112,18 @@
         "muSchedAccessReqInterval",
         "Duration of the interval between two requests for channel access made by the MU scheduler",
         accessReqInterval);
-    cmd.AddValue("mcs", "if set, limit testing to a specific MCS (0-11)", mcs);
+    cmd.AddValue(
+        "mcs",
+        "list of comma separated MCS values to test; if unset, all MCS values (0-11) are tested",
+        mcsStr);
+    cmd.AddValue("channelWidth",
+                 "if set, limit testing to a specific channel width expressed in MHz (20, 40, 80 "
+                 "or 160 MHz)",
+                 channelWidth);
+    cmd.AddValue("guardInterval",
+                 "if set, limit testing to a specific guard interval duration expressed in "
+                 "nanoseconds (800, 1600 or 3200 ns)",
+                 guardInterval);
     cmd.AddValue("payloadSize", "The application payload size in bytes", payloadSize);
     cmd.AddValue("phyModel",
                  "PHY model to use when OFDMA is disabled (Yans or Spectrum). If 80+80 MHz or "
@@ -168,25 +184,51 @@
               << "GI"
               << "\t\t\t"
               << "Throughput" << '\n';
-    int minMcs = 0;
-    int maxMcs = 11;
-    if (mcs >= 0 && mcs <= 11)
+    uint8_t minMcs = 0;
+    uint8_t maxMcs = 11;
+
+    if (mcsStr.empty())
+    {
+        for (uint8_t mcs = minMcs; mcs <= maxMcs; ++mcs)
+        {
+            mcsValues.push_back(mcs);
+        }
+    }
+    else
     {
-        minMcs = mcs;
-        maxMcs = mcs;
+        AttributeContainerValue<UintegerValue, ',', std::vector> attr;
+        auto checker = DynamicCast<AttributeContainerChecker>(MakeAttributeContainerChecker(attr));
+        checker->SetItemChecker(MakeUintegerChecker<uint8_t>());
+        attr.DeserializeFromString(mcsStr, checker);
+        mcsValues = attr.Get();
+        std::sort(mcsValues.begin(), mcsValues.end());
     }
-    for (int mcs = minMcs; mcs <= maxMcs; mcs++)
+
+    int minChannelWidth = 20;
+    int maxChannelWidth = frequency == 2.4 ? 40 : 160;
+    if (channelWidth >= minChannelWidth && channelWidth <= maxChannelWidth)
+    {
+        minChannelWidth = channelWidth;
+        maxChannelWidth = channelWidth;
+    }
+    int minGi = enableUlOfdma ? 1600 : 800;
+    int maxGi = 3200;
+    if (guardInterval >= minGi && guardInterval <= maxGi)
+    {
+        minGi = guardInterval;
+        maxGi = guardInterval;
+    }
+
+    for (const auto mcs : mcsValues)
     {
         uint8_t index = 0;
         double previous = 0;
-        uint8_t maxChannelWidth = frequency == 2.4 ? 40 : 160;
-        int minGi = enableUlOfdma ? 1600 : 800;
-        for (int channelWidth = 20; channelWidth <= maxChannelWidth;) // MHz
+        for (int width = minChannelWidth; width <= maxChannelWidth; width *= 2) // MHz
         {
-            const auto is80Plus80 = (use80Plus80 && (channelWidth == 160));
-            const std::string widthStr = is80Plus80 ? "80+80" : std::to_string(channelWidth);
+            const auto is80Plus80 = (use80Plus80 && (width == 160));
+            const std::string widthStr = is80Plus80 ? "80+80" : std::to_string(width);
             const auto segmentWidthStr = is80Plus80 ? "80" : widthStr;
-            for (int gi = 3200; gi >= minGi;) // Nanoseconds
+            for (int gi = maxGi; gi >= minGi; gi /= 2) // Nanoseconds
             {
                 if (!udp)
                 {
@@ -357,7 +399,8 @@
                 }
 
                 const auto maxLoad =
-                    HePhy::GetDataRate(mcs, channelWidth, NanoSeconds(gi), 1) / nStations;
+                    HePhy::GetDataRate(mcs, MHz_u{static_cast<double>(width)}, NanoSeconds(gi), 1) /
+                    nStations;
                 if (udp)
                 {
                     // UDP flow
@@ -366,8 +409,8 @@
                     serverApp = server.Install(serverNodes.get());
                     streamNumber += server.AssignStreams(serverNodes.get(), streamNumber);
 
-                    serverApp.Start(Seconds(0.0));
-                    serverApp.Stop(simulationTime + Seconds(1.0));
+                    serverApp.Start(Seconds(0));
+                    serverApp.Stop(simulationTime + Seconds(1));
                     const auto packetInterval = payloadSize * 8.0 / maxLoad;
 
                     for (std::size_t i = 0; i < nStations; i++)
@@ -379,8 +422,8 @@
                         ApplicationContainer clientApp = client.Install(clientNodes.Get(i));
                         streamNumber += client.AssignStreams(clientNodes.Get(i), streamNumber);
 
-                        clientApp.Start(Seconds(1.0));
-                        clientApp.Stop(simulationTime + Seconds(1.0));
+                        clientApp.Start(Seconds(1));
+                        clientApp.Stop(simulationTime + Seconds(1));
                     }
                 }
                 else
@@ -392,8 +435,8 @@
                     serverApp = packetSinkHelper.Install(serverNodes.get());
                     streamNumber += packetSinkHelper.AssignStreams(serverNodes.get(), streamNumber);
 
-                    serverApp.Start(Seconds(0.0));
-                    serverApp.Stop(simulationTime + Seconds(1.0));
+                    serverApp.Start(Seconds(0));
+                    serverApp.Stop(simulationTime + Seconds(1));
 
                     for (std::size_t i = 0; i < nStations; i++)
                     {
@@ -410,14 +453,14 @@
                         ApplicationContainer clientApp = onoff.Install(clientNodes.Get(i));
                         streamNumber += onoff.AssignStreams(clientNodes.Get(i), streamNumber);
 
-                        clientApp.Start(Seconds(1.0));
-                        clientApp.Stop(simulationTime + Seconds(1.0));
+                        clientApp.Start(Seconds(1));
+                        clientApp.Stop(simulationTime + Seconds(1));
                     }
                 }
 
                 Simulator::Schedule(Seconds(0), &Ipv4GlobalRoutingHelper::PopulateRoutingTables);
 
-                Simulator::Stop(simulationTime + Seconds(1.0));
+                Simulator::Stop(simulationTime + Seconds(1));
                 Simulator::Run();
 
                 // When multiple stations are used, there are chances that association requests
@@ -450,7 +493,7 @@
                           << " Mbit/s" << std::endl;
 
                 // test first element
-                if (mcs == minMcs && channelWidth == 20 && gi == 3200)
+                if (mcs == minMcs && width == 20 && gi == 3200)
                 {
                     if (throughput * (1 + tolerance) < minExpectedThroughput)
                     {
@@ -459,7 +502,7 @@
                     }
                 }
                 // test last element
-                if (mcs == maxMcs && channelWidth == maxChannelWidth && gi == 800)
+                if (mcs == maxMcs && width == maxChannelWidth && gi == 800)
                 {
                     if (maxExpectedThroughput > 0 &&
                         throughput > maxExpectedThroughput * (1 + tolerance))
@@ -495,9 +538,7 @@
                     }
                 }
                 index++;
-                gi /= 2;
             }
-            channelWidth *= 2;
         }
     }
     return 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/examples/wireless/wifi-hidden-terminal.cc ns-3.44/examples/wireless/wifi-hidden-terminal.cc
--- ns-3.43/examples/wireless/wifi-hidden-terminal.cc	2024-10-09 16:41:09.840655800 -0700
+++ ns-3.44/examples/wireless/wifi-hidden-terminal.cc	2025-03-09 16:55:49.339371000 -0700
@@ -38,8 +38,8 @@
 /**
  * Run single 10 seconds experiment
  *
- * \param enableCtsRts if true, enable RTS/CTS for packets larger than 100 bytes.
- * \param wifiManager WiFi manager to use.
+ * @param enableCtsRts if true, enable RTS/CTS for packets larger than 100 bytes.
+ * @param wifiManager WiFi manager to use.
  */
 void
 experiment(bool enableCtsRts, std::string wifiManager)
@@ -115,7 +115,7 @@
 
     // flow 2:  node 2 -> node 1
     /**
-     * \internal
+     * @internal
      * The slightly different start times and data rates are a workaround
      * for \bugid{388} and \bugid{912}
      */
@@ -124,13 +124,13 @@
     cbrApps.Add(onOffHelper.Install(nodes.Get(2)));
 
     /**
-     * \internal
+     * @internal
      * We also use separate UDP applications that will send a single
      * packet before the CBR flows start.
      * This is a workaround for the lack of perfect ARP, see \bugid{187}
      */
     uint16_t echoPort = 9;
-    UdpEchoClientHelper echoClientHelper(Ipv4Address("10.0.0.2"), echoPort);
+    UdpEchoClientHelper echoClientHelper(InetSocketAddress(Ipv4Address("10.0.0.2"), echoPort));
     echoClientHelper.SetAttribute("MaxPackets", UintegerValue(1));
     echoClientHelper.SetAttribute("Interval", TimeValue(Seconds(0.1)));
     echoClientHelper.SetAttribute("PacketSize", UintegerValue(10));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/examples/wireless/wifi-ht-network.cc ns-3.44/examples/wireless/wifi-ht-network.cc
--- ns-3.43/examples/wireless/wifi-ht-network.cc	2024-10-09 16:41:09.840655800 -0700
+++ ns-3.44/examples/wireless/wifi-ht-network.cc	2025-03-09 16:55:49.339371000 -0700
@@ -31,6 +31,9 @@
 #include "ns3/yans-wifi-channel.h"
 #include "ns3/yans-wifi-helper.h"
 
+#include <algorithm>
+#include <vector>
+
 // This is a simple example in order to show how to configure an IEEE 802.11n Wi-Fi network.
 //
 // It outputs the UDP or TCP goodput for every HT MCS value, which depends on the MCS value (0 to
@@ -59,7 +62,10 @@
     Time simulationTime{"10s"};
     meter_u distance{1.0};
     double frequency{5}; // whether 2.4 or 5 GHz
-    int mcs{-1};         // -1 indicates an unset value
+    std::string mcsStr;
+    std::vector<uint64_t> mcsValues;
+    int channelWidth{-1};  // in MHz, -1 indicates an unset value
+    int guardInterval{-1}; // in nanoseconds, -1 indicates an unset value
     double minExpectedThroughput{0.0};
     double maxExpectedThroughput{0.0};
 
@@ -73,7 +79,18 @@
     cmd.AddValue("simulationTime", "Simulation time", simulationTime);
     cmd.AddValue("udp", "UDP if set to 1, TCP otherwise", udp);
     cmd.AddValue("useRts", "Enable/disable RTS/CTS", useRts);
-    cmd.AddValue("mcs", "if set, limit testing to a specific MCS (0-7)", mcs);
+    cmd.AddValue(
+        "mcs",
+        "list of comma separated MCS values to test; if unset, all MCS values (0-7) are tested",
+        mcsStr);
+    cmd.AddValue(
+        "channelWidth",
+        "if set, limit testing to a specific channel width expressed in MHz (20 or 40 MHz)",
+        channelWidth);
+    cmd.AddValue("guardInterval",
+                 "if set, limit testing to a specific guard interval duration expressed in "
+                 "nanoseconds (800 or 400 ns)",
+                 guardInterval);
     cmd.AddValue("minExpectedThroughput",
                  "if set, simulation fails if the lowest throughput is below this value",
                  minExpectedThroughput);
@@ -96,21 +113,50 @@
               << "short GI"
               << "\t\t"
               << "Throughput" << '\n';
-    int minMcs = 0;
-    int maxMcs = 7;
-    if (mcs >= 0 && mcs <= 7)
+    uint8_t minMcs = 0;
+    uint8_t maxMcs = 7;
+
+    if (mcsStr.empty())
+    {
+        for (uint8_t mcs = minMcs; mcs <= maxMcs; ++mcs)
+        {
+            mcsValues.push_back(mcs);
+        }
+    }
+    else
     {
-        minMcs = mcs;
-        maxMcs = mcs;
+        AttributeContainerValue<UintegerValue, ',', std::vector> attr;
+        auto checker = DynamicCast<AttributeContainerChecker>(MakeAttributeContainerChecker(attr));
+        checker->SetItemChecker(MakeUintegerChecker<uint8_t>());
+        attr.DeserializeFromString(mcsStr, checker);
+        mcsValues = attr.Get();
+        std::sort(mcsValues.begin(), mcsValues.end());
     }
-    for (int mcs = minMcs; mcs <= maxMcs; mcs++)
+
+    int minChannelWidth = 20;
+    int maxChannelWidth = 40;
+    if (channelWidth >= minChannelWidth && channelWidth <= maxChannelWidth)
+    {
+        minChannelWidth = channelWidth;
+        maxChannelWidth = channelWidth;
+    }
+    int minGi = 400;
+    int maxGi = 800;
+    if (guardInterval >= minGi && guardInterval <= maxGi)
+    {
+        minGi = guardInterval;
+        maxGi = guardInterval;
+    }
+
+    for (const auto mcs : mcsValues)
     {
         uint8_t index = 0;
         double previous = 0;
-        for (int channelWidth = 20; channelWidth <= 40;)
+        for (int width = minChannelWidth; width <= maxChannelWidth; width *= 2) // MHz
         {
-            for (auto sgi : {false, true})
+            for (int gi = maxGi; gi >= minGi; gi /= 2) // Nanoseconds
             {
+                const auto sgi = (gi == 400);
                 uint32_t payloadSize; // 1500 byte IP packet
                 if (udp)
                 {
@@ -171,7 +217,7 @@
                     ';'>
                     channelValue;
                 WifiPhyBand band = (frequency == 5.0 ? WIFI_PHY_BAND_5GHZ : WIFI_PHY_BAND_2_4GHZ);
-                channelValue.Set(WifiPhy::ChannelSegments{{0, channelWidth, band, 0}});
+                channelValue.Set(WifiPhy::ChannelSegments{{0, width, band, 0}});
 
                 mac.SetType("ns3::StaWifiMac", "Ssid", SsidValue(ssid));
                 phy.Set("ChannelSettings", channelValue);
@@ -221,8 +267,10 @@
                 apNodeInterface = address.Assign(apDevice);
 
                 /* Setting applications */
-                const auto maxLoad =
-                    HtPhy::GetDataRate(mcs, channelWidth, NanoSeconds(sgi ? 400 : 800), 1);
+                const auto maxLoad = HtPhy::GetDataRate(mcs,
+                                                        MHz_u{static_cast<double>(width)},
+                                                        NanoSeconds(sgi ? 400 : 800),
+                                                        1);
                 ApplicationContainer serverApp;
                 if (udp)
                 {
@@ -232,8 +280,8 @@
                     serverApp = server.Install(wifiStaNode.Get(0));
                     streamNumber += server.AssignStreams(wifiStaNode.Get(0), streamNumber);
 
-                    serverApp.Start(Seconds(0.0));
-                    serverApp.Stop(simulationTime + Seconds(1.0));
+                    serverApp.Start(Seconds(0));
+                    serverApp.Stop(simulationTime + Seconds(1));
                     const auto packetInterval = payloadSize * 8.0 / maxLoad;
 
                     UdpClientHelper client(staNodeInterface.GetAddress(0), port);
@@ -243,8 +291,8 @@
                     ApplicationContainer clientApp = client.Install(wifiApNode.Get(0));
                     streamNumber += client.AssignStreams(wifiApNode.Get(0), streamNumber);
 
-                    clientApp.Start(Seconds(1.0));
-                    clientApp.Stop(simulationTime + Seconds(1.0));
+                    clientApp.Start(Seconds(1));
+                    clientApp.Stop(simulationTime + Seconds(1));
                 }
                 else
                 {
@@ -256,8 +304,8 @@
                     streamNumber +=
                         packetSinkHelper.AssignStreams(wifiStaNode.Get(0), streamNumber);
 
-                    serverApp.Start(Seconds(0.0));
-                    serverApp.Stop(simulationTime + Seconds(1.0));
+                    serverApp.Start(Seconds(0));
+                    serverApp.Stop(simulationTime + Seconds(1));
 
                     OnOffHelper onoff("ns3::TcpSocketFactory", Ipv4Address::GetAny());
                     onoff.SetAttribute("OnTime",
@@ -272,13 +320,13 @@
                     ApplicationContainer clientApp = onoff.Install(wifiApNode.Get(0));
                     streamNumber += onoff.AssignStreams(wifiApNode.Get(0), streamNumber);
 
-                    clientApp.Start(Seconds(1.0));
-                    clientApp.Stop(simulationTime + Seconds(1.0));
+                    clientApp.Start(Seconds(1));
+                    clientApp.Stop(simulationTime + Seconds(1));
                 }
 
                 Ipv4GlobalRoutingHelper::PopulateRoutingTables();
 
-                Simulator::Stop(simulationTime + Seconds(1.0));
+                Simulator::Stop(simulationTime + Seconds(1));
                 Simulator::Run();
 
                 auto rxBytes = 0.0;
@@ -294,11 +342,11 @@
 
                 Simulator::Destroy();
 
-                std::cout << mcs << "\t\t\t" << channelWidth << " MHz\t\t\t" << std::boolalpha
-                          << sgi << "\t\t\t" << throughput << " Mbit/s" << std::endl;
+                std::cout << mcs << "\t\t\t" << width << " MHz\t\t\t" << std::boolalpha << sgi
+                          << "\t\t\t" << throughput << " Mbit/s" << std::endl;
 
                 // test first element
-                if (mcs == minMcs && channelWidth == 20 && !sgi)
+                if (mcs == minMcs && width == 20 && !sgi)
                 {
                     if (throughput < minExpectedThroughput)
                     {
@@ -306,7 +354,7 @@
                     }
                 }
                 // test last element
-                if (mcs == maxMcs && channelWidth == 40 && sgi)
+                if (mcs == maxMcs && width == 40 && sgi)
                 {
                     if (maxExpectedThroughput > 0 && throughput > maxExpectedThroughput)
                     {
@@ -333,7 +381,6 @@
                 }
                 index++;
             }
-            channelWidth *= 2;
         }
     }
     return 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/examples/wireless/wifi-mixed-network.cc ns-3.44/examples/wireless/wifi-mixed-network.cc
--- ns-3.43/examples/wireless/wifi-mixed-network.cc	2024-10-09 16:41:09.840655800 -0700
+++ ns-3.44/examples/wireless/wifi-mixed-network.cc	2025-03-09 16:55:49.339371000 -0700
@@ -79,8 +79,8 @@
     Experiment();
     /**
      * Run an experiment with the given parameters
-     * \param params the given parameters
-     * \return the throughput
+     * @param params the given parameters
+     * @return the throughput
      */
     double Run(Parameters params);
 };
@@ -265,8 +265,8 @@
         uint16_t port = 9;
         UdpServerHelper server(port);
         ApplicationContainer serverApp = server.Install(wifiApNode);
-        serverApp.Start(Seconds(0.0));
-        serverApp.Stop(simulationTime + Seconds(1.0));
+        serverApp.Start(Seconds(0));
+        serverApp.Stop(simulationTime + Seconds(1));
 
         UdpClientHelper client(ApInterface.GetAddress(0), port);
         client.SetAttribute("MaxPackets", UintegerValue(4294967295U));
@@ -286,10 +286,10 @@
         {
             clientApps.Add(client.Install(wifiNStaNodes));
         }
-        clientApps.Start(Seconds(1.0));
-        clientApps.Stop(simulationTime + Seconds(1.0));
+        clientApps.Start(Seconds(1));
+        clientApps.Stop(simulationTime + Seconds(1));
 
-        Simulator::Stop(simulationTime + Seconds(1.0));
+        Simulator::Stop(simulationTime + Seconds(1));
         Simulator::Run();
 
         double totalPacketsThrough = DynamicCast<UdpServer>(serverApp.Get(0))->GetReceived();
@@ -302,8 +302,8 @@
         PacketSinkHelper packetSinkHelper("ns3::TcpSocketFactory", localAddress);
 
         ApplicationContainer serverApp = packetSinkHelper.Install(wifiApNode.Get(0));
-        serverApp.Start(Seconds(0.0));
-        serverApp.Stop(simulationTime + Seconds(1.0));
+        serverApp.Start(Seconds(0));
+        serverApp.Stop(simulationTime + Seconds(1));
 
         OnOffHelper onoff("ns3::TcpSocketFactory", Ipv4Address::GetAny());
         onoff.SetAttribute("OnTime", StringValue("ns3::ConstantRandomVariable[Constant=1]"));
@@ -327,10 +327,10 @@
         {
             clientApps.Add(onoff.Install(wifiNStaNodes));
         }
-        clientApps.Start(Seconds(1.0));
-        clientApps.Stop(simulationTime + Seconds(1.0));
+        clientApps.Start(Seconds(1));
+        clientApps.Stop(simulationTime + Seconds(1));
 
-        Simulator::Stop(simulationTime + Seconds(1.0));
+        Simulator::Stop(simulationTime + Seconds(1));
         Simulator::Run();
 
         double totalPacketsThrough = DynamicCast<PacketSink>(serverApp.Get(0))->GetTotalRx();
